function [aa,da]=get_aa_dat
global ga xb yb xm ym bel nbp aa L_da U_da x_t y_t n_t n_p;
% SETUP THE COEFFICIENTS MATRIX AA(I,J) and DA(I,J). -Laplace u+ga u=0.  %ga>0 
% Interior domain, dir=1<=>counterclockwise, exterior domain, dir=-1<=>clockwise
[rint,wint]=gpt_dat;      %get Guass points and weights   
ng = 4;    ng2=ng-1;      % use 4-point Gauss integration formula
one_r=ones(1,nbp);        %a row of 1's
Delta=diag(one_r);        %Dirac Delta function
aa=zeros(nbp,nbp);
da=0.5*Delta;

if ga <= 10.^(-8)   %level 0

for i=1:nbp
  xn_i = +(yb(i+1)-yb(i))/bel(i);
  yn_i = -(xb(i+1)-xb(i))/bel(i);         %unit out-normal
  for j=1:nbp
    ax = xb(j);
    bx = xb(j+1);
    ay = yb(j);
    by = yb(j+1);
    for k=1:ng           %Gauss integration
      gx = 0.5*((bx-ax)*rint(ng2,k)+bx+ax);
      gy = 0.5*((by-ay)*rint(ng2,k)+by+ay);
      gc = 0.5*bel(j)*wint(ng2,k);
      dis = sqrt((xm(i)-gx)^2+(ym(i)-gy)^2);
      aa(i,j) = aa(i,j) - gc/(2*pi)*log(dis);
      da(i,j) = da(i,j)-(1-Delta(i,j))*gc/(2*pi)*((xm(i)-gx)*xn_i+(ym(i)-gy)*yn_i)/dis^2;
    end
  end
end

else

for i=1:nbp
  xn_i = +(yb(i+1)-yb(i))/bel(i);
  yn_i = -(xb(i+1)-xb(i))/bel(i);         %unit out-normal
  for j=1:nbp
    ax = xb(j);
    bx = xb(j+1);
    ay = yb(j);
    by = yb(j+1);
    for k=1:ng           %Gauss integration
      gx = 0.5*((bx-ax)*rint(ng2,k)+bx+ax);
      gy = 0.5*((by-ay)*rint(ng2,k)+by+ay);
      gc = 0.5*bel(j)*wint(ng2,k);
      dis = sqrt((xm(i)-gx)^2+(ym(i)-gy)^2);
      wk = ga*dis;
      aa(i,j) = aa(i,j) + gc/(2*pi)*besselk(0,wk);
      da(i,j) = da(i,j)-(1-Delta(i,j))*gc*ga/(2*pi)*besselk(1,wk)*((xm(i)-gx)*xn_i+(ym(i)-gy)*yn_i)/dis;
    end
  end
end
end %level 0
